unit UnitMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, Series, TeeProcs, Chart, ExtCtrls, Menus, ComCtrls, UnitDFT,
  StdCtrls;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    NFile: TMenuItem;
    NLoad: TMenuItem;
    NSave: TMenuItem;
    NExit: TMenuItem;
    NHelp: TMenuItem;
    NAbout: TMenuItem;
    Timer1: TTimer;
    PanelLeft: TPanel;
    SplitterLeft: TSplitter;
    PanelMain: TPanel;
    PanelChart: TPanel;
    PanelProc: TPanel;
    PanelRight: TPanel;
    SplitterRight: TSplitter;
    ChartSpectr: TChart;
    ChartF: TChart;
    OpenDialog1: TOpenDialog;
    RichEdit1: TRichEdit;
    Series1: TAreaSeries;
    Series2: TLineSeries;
    PanelSpectr: TPanel;
    PanelF: TPanel;
    GroupBox1: TGroupBox;
    CheckBoxAutoX: TCheckBox;
    EditMaxX: TEdit;
    ButtonXAxis: TButton;
    GroupBox2: TGroupBox;
    EditScaleX: TEdit;
    Label1: TLabel;
    ComboBoxEn_2: TComboBox;
    ButtonDateRefresh: TButton;
    CheckBoxH0: TCheckBox;
    Label2: TLabel;
    Label3: TLabel;
    EditADC: TEdit;
    ProgressBar1: TProgressBar;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    EditKmax: TEdit;
    GroupBox4: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    EditStartPattern: TEdit;
    EditWidthPattern: TEdit;
    ButtonStartKor: TButton;
    ProgressBar2: TProgressBar;
    Series3: TLineSeries;
    CheckBoxViewF: TCheckBox;
    CheckBoxViewS: TCheckBox;
    procedure NExitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure NLoadClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ButtonXAxisClick(Sender: TObject);
    procedure CheckBoxAutoXClick(Sender: TObject);
    procedure ButtonDateRefreshClick(Sender: TObject);
    procedure RichEdit1Change(Sender: TObject);
    procedure ButtonStartKorClick(Sender: TObject);
    procedure CheckBoxMarkClick(Sender: TObject);
    procedure Series2Click(Sender: TChartSeries; ValueIndex: Integer;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Series3Click(Sender: TChartSeries; ValueIndex: Integer;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure CheckBoxViewFClick(Sender: TObject);
    procedure CheckBoxViewSClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure RefreshString;
    procedure PrepareFint;
    procedure CreateSpectr;
    procedure SamplCorrelation;
  end;

var
  Form1: TForm1;
  DFT:TDFT;

  DataStream: TMemoryStream;
  Pattern: TMemoryStream;
  ChangString: boolean;
  ErrorString: longint;
  Save_Cursor:TCursor;
  StartPattern,WidthPattern:longint;
  FaktPrepareFint:boolean;

implementation

{$R *.dfm}

procedure TForm1.NExitClick(Sender: TObject);
begin
 Close;
end;

procedure TForm1.PrepareFint;
var
 n:word;
 pr:real;
 f:real;
 pr_int,S,Sr:integer;
 st:string;
 avg:real;
 ScaleX:real;
 cod:integer;
begin
 S:= sizeof(pr_int);
// ChartF.Series[0].Clear;
 DFT.Fint.Seek(0,soFromBeginning);
 Sr:=sizeof(pr);

 avg:=0;
 if CheckBoxH0.Checked then avg:=DFT.Avg*DFT.ADC;

 DataStream.Seek(0, soFromBeginning);
 for n:=0 to DFT.nmax-1 do
  begin
   DataStream.ReadBuffer(pr,Sr);
   pr_int:= round(pr*DFT.ADC - avg);
   DFT.fint.WriteBuffer(pr_int,S);

   Val(EditScaleX.Text,ScaleX,cod);
   st:=inttostr(n*round(ScaleX));
//   st:=inttostr(n);
//   st:=st+'uS';
st:='';
   ChartF.Series[0].AddXY(n,pr_int,st);
  end;
 FaktPrepareFint:=true;

end;

procedure TForm1.CreateSpectr;
var
 k:word;
 Re,Im,Ampl:real;
begin
// ChartSpectr.Series[0].Clear;
 for k:=0 to DFT.kmax-1 do
 begin
   Re:=DFT.ReDFTQ(k);
   Im:=DFT.ImDFTQ(k);
   Ampl:=Sqrt(Re*Re+Im*Im);
   ChartSpectr.Series[0].AddXY(k,Ampl);
 end;

end;


procedure TForm1.FormCreate(Sender: TObject);
begin
 DFT := TDFT.Create;
 CheckBoxAutoX.Checked:=true;
 ChartF.BottomAxis.Automatic:=CheckBoxAutoX.Checked;
 EditMaxX.Enabled:= not CheckBoxAutoX.Checked;
 DataStream := TMemoryStream.Create;
 Pattern := TMemoryStream.Create;
end;

procedure TForm1.RefreshString;
var
  n:longint;
  Ls:longint;
  pr,sum:real;
  Ll:integer;
  cod:integer;
  ErrorSel,CountChar:longint;

  st:string;
begin
   Save_Cursor := Screen.Cursor;
   Screen.Cursor := crHourGlass;    { Show hourglass cursor }
   try
//**********************************************************
     sum:=0;
     Ls:=0;
    DataStream.Seek(0, soFromBeginning);
    ErrorString:=-1;
    ProgressBar1.Max:= RichEdit1.Lines.Count;
    ProgressBar1.Position:=0;

    for n:=0 to RichEdit1.Lines.Count - 1 do
    begin
      st:=RichEdit1.Lines[n];
      Ll:=Length(st);
      if st[Ll] = #9 then Delete(st,Ll,1);
      Val(st,pr,cod);
      if cod = 0 then
      begin
       DataStream.WriteBuffer(pr,Sizeof(pr));
       sum:=sum+pr;
       Ls:=Ls+1;
        ProgressBar1.Position:=Ls;
      end else
      if RichEdit1.Lines[n] <> '' then
         begin
          ErrorString:=n;
          break;
         end;
    end;
    ProgressBar1.Position:=0;
    if Ls <> 0 then
    begin
     DFT.nmax:=Ls;
     DFT.Avg:=sum / Ls;
    end else
    begin
     DFT.nmax:=1;
      DFT.Avg:=0;
    end;

    StatusBar1.Panels[0].Text:=' : '+inttostr(DFT.nmax);
    StatusBar1.Panels[1].Text:=': '+ FloatToStrF(DFT.Avg,ffGeneral,4,4);
    if ErrorString <> -1 then
      begin
        StatusBar1.Panels[2].Text:='   '+inttostr(ErrorString+1)+'   '+inttostr(cod);
        RichEdit1.SetFocus;
        RichEdit1.SelectAll;
        CountChar:=RichEdit1.SelLength;
        ErrorSel:=RichEdit1.FindText(st,0,CountChar,[stMatchCase]);
        RichEdit1.SelStart:=ErrorSel;
        RichEdit1.SelLength:=length(st);
//        RichEdit1.ScrollBy(0,ErrorString+1);
      end
        else StatusBar1.Panels[2].Text:='';
    if ErrorString = -1 then ChangString := false;
//**********************************************************
   finally
    Screen.Cursor := Save_Cursor;
   end;

end;

procedure TForm1.NLoadClick(Sender: TObject);
begin
 if OpenDialog1.Execute then
  begin
   RichEdit1.Clear;
   RichEdit1.Lines.LoadFromFile(OpenDialog1.FileName);
   RefreshString;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   FreeAndNil(DataStream);
   FreeAndNil(DFT.sin_nmax);
   FreeAndNil(DFT.cos_nmax);
   FreeAndNil(DFT.fint);
   FreeAndNil(Pattern);
 end;

procedure TForm1.ButtonXAxisClick(Sender: TObject);
var cod:integer;
i:integer;
begin
 ChartF.BottomAxis.Automatic:=CheckBoxAutoX.Checked;
 EditMaxX.Enabled:= not CheckBoxAutoX.Checked;
 Val(EditMaxX.Text,i,cod);
 if cod = 0 then ChartF.BottomAxis.Maximum:=i;
end;

procedure TForm1.CheckBoxAutoXClick(Sender: TObject);
begin
 EditMaxX.Enabled:= not CheckBoxAutoX.Checked;
 ChartF.BottomAxis.Automatic:=CheckBoxAutoX.Checked;
end;

procedure TForm1.ButtonDateRefreshClick(Sender: TObject);
var cod:integer;
adc:integer;
begin
   Val(EditKmax.Text,adc,cod);
   if cod = 0 then DFT.kmax:=adc else DFT.kmax:=32;
   if adc <= 0 then DFT.kmax:=32;

   Val(EditADC.Text,adc,cod);
   if cod = 0 then DFT.ADC:=adc;

   if ChangString then RefreshString;

   ChartF.Series[0].Clear;
   ChartSpectr.Series[0].Clear;
   if ErrorString = -1 then
   begin
    DFT.SetParam;
    PrepareFint;
    CreateSpectr;
   end;
end;

procedure TForm1.RichEdit1Change(Sender: TObject);
begin
  ChangString := true;
end;

procedure TForm1.ButtonStartKorClick(Sender: TObject);
var cod:integer;
pr:longint;
begin
   if not FaktPrepareFint then
   begin
    StatusBar1.Panels[2].Text:='  ';
    exit;
   end else  StatusBar1.Panels[2].Text:='';

   Val(EditStartPattern.Text,pr,cod);
   if cod = 0 then StartPattern:=pr else StartPattern:=0;
   Val(EditWidthPattern.Text,pr,cod);
   if cod = 0 then WidthPattern:=pr else WidthPattern:=1;
   if WidthPattern = 0 then WidthPattern:=1;

   if StartPattern+WidthPattern > DFT.nmax then
   begin
    StartPattern:=0;
    WidthPattern:=1;
//    StatusBar1.Panels[2].Text:=' ';
   end;


   ChartF.Series[1].Clear;
   SamplCorrelation;
end;

procedure TForm1.SamplCorrelation;

//Cov(XY) =  1/n * Sum( (X(n)-U(x))*(Y(n)-U(y)))
// n -  
// Sum - 
// X(n) - n-   1
// Y(n) - n-   2
// U(x) -   1
// U(y) -   2


var
 n:longint;
 pn:integer;
 pr_int,pat_int:integer;
 Sr:integer;
 sum,dx,dy,mx,my:longint;
 cov:integer;
 cor:real;
 st:string;

 avg_pat,avg_dat:longint;

begin

//  
 st:='';
 Sr:=sizeof(pr_int);
 Pattern.Seek(0, soFromBeginning);
 DFT.fint.Seek(StartPattern*Sr,soFromBeginning);
 sum:=0;

 for n:=0 to WidthPattern-1 do
  begin
   DFT.fint.ReadBuffer(pr_int,Sr);
   Pattern.WriteBuffer(pr_int,Sr);
   sum:=sum + pr_int;
  end;
 avg_pat:=round(sum / WidthPattern);
//  ,   

 Pattern.Seek(0, soFromBeginning);
 DFT.fint.Seek(StartPattern*Sr, soFromBeginning);

 for n:=0 to DFT.nmax-WidthPattern do
  begin
   sum:=0;
   dx:=0;
   dy:=0;
   DFT.fint.Seek(n*Sr, soFromBeginning);
   for pn:=0 to WidthPattern-1 do
    begin
     DFT.fint.ReadBuffer(pr_int,Sr);
     sum:=sum + pr_int;
    end;
   avg_dat:= round(sum / WidthPattern);
//    
   sum:=0;
   DFT.fint.Seek(n*Sr, soFromBeginning);
   Pattern.Seek(0, soFromBeginning);
   for pn:=0 to WidthPattern-1 do
    begin
     DFT.fint.ReadBuffer(pr_int,Sr);
     Pattern.ReadBuffer(pat_int,Sr);
     mx:=pr_int - avg_dat;
     my:=pat_int - avg_pat;
     sum:=sum + mx*my;
     dx:=dx+mx*mx;
     dy:=dy+my*my;
    end;
    if (dx=0) or (dy=0) then
      cov :=0 else  cov:= round(sum /(sqrt(dx)*sqrt(dy))*100);

    ChartF.Series[1].AddXY(n,cov,st);
  end;


end;

procedure TForm1.CheckBoxMarkClick(Sender: TObject);
begin
// ChartF.Series[0].Marks.visible:=CheckBoxMark.Checked;
end;

procedure TForm1.Series2Click(Sender: TChartSeries; ValueIndex: Integer;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  var st:string;
begin
 st:= 'X: '+inttostr(ValueIndex)+'  Y:'+ floattostr(ChartF.Series[0].YValue[ValueIndex]);
 StatusBar1.Panels[2].Text:=st;
 ChartF.Hint:=st;
 ChartF.ShowHint:=true;
 Application.ShowHint := True;
end;

procedure TForm1.Series3Click(Sender: TChartSeries; ValueIndex: Integer;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
 var st:string;
begin
 st:= 'X: '+inttostr(ValueIndex)+'  Y:'+ floattostr(ChartF.Series[1].YValue[ValueIndex]);
 StatusBar1.Panels[2].Text:=st;
 ChartF.Hint:=st;
 ChartF.ShowHint:=true;
 Application.ShowHint := True;

end;

procedure TForm1.CheckBoxViewFClick(Sender: TObject);
begin

 if Not CheckBoxViewF.checked then
  begin
   Series2.LinePen.Style:=psClear;
   Series2.Pointer.Visible:=false;
  end else
  begin
   Series2.LinePen.Style:=psSolid;
   Series2.Pointer.Visible:=true;
  end;
end;

procedure TForm1.CheckBoxViewSClick(Sender: TObject);
begin

 if Not CheckBoxViewS.checked then
  begin
   Series3.LinePen.Style:=psClear;
   Series3.Pointer.Visible:=false;
  end else
  begin
   Series3.LinePen.Style:=psSolid;
   Series3.Pointer.Visible:=true;
  end;

end;

end.
